#cs ===============================================================================

   Virtual Keyboard v1.1 - 13.05.2005
   Autor: Lazycat

   Features:

       - two layouts - English and Russian (possibly add another by adding 3 lines of code)
       - copying result to clipboard
       - sending result directly to visible windows

   Requirements:
       
       Autoit 3.1+

   Where Autoit limits are?..

#ce ===============================================================================

#include <GUIConstants.au3>

Global $EM_GETSEL = 0x00B0
Global $EM_SETSEL = 0x00B1
Global $EM_SCROLLCARET = 0x00B7
Global $WM_CONTEXTMENU = 0x7B

Global $aKeys[47][5], $nCnt = -1, $nX = 10, $nY = 120, $ncX = 10, $nIncrX = 45
Global $BTN_STYLE = BitOr($BS_CHECKBOX, $BS_PUSHLIKE)

$aLayoutNum = StringSplit("14,12,11,10", ",")

; ******************************* Layouts definition ******************************

; Layout that will be active at start
$nDefLayout = 1

; Abbreviation of language
Global $aLang[2]
$aLang[0] = "ENG"
$aLang[1] = "RUS"

; Layouts definition (even item is normal state, odd - shifted state)
Global $aKeyString[4]
$aKeyString[0] = "`1234567890-=\qwertyuiop[]asdfghjkl;'zxcvbnm,./"
$aKeyString[1] = "~!@#$%^&*()_+|QWERTYUIOP{}ASDFGHJKL:"&chr(39)&"ZXCVBNM<>?"
$aKeyString[2] = "1234567890-=\."
$aKeyString[3] = "!"&chr(39)&";%:?*()_+/,"

; *********************************************************************************

$hGUI = GUICreate("Virtual Keyboard", 455,280)

For $i = 1 To 4
    For $j = 1 To Number($aLayoutNum[$i])
        $nCnt = $nCnt + 1
        $aKeys[$nCnt][0]=GUICtrlCreateButton("", 30*($j-1)+$ncX,  $nY+30*($i-1), 30, 30, $BTN_STYLE)
        For $k = 1 To UBound($aKeyString)
            $aKeys[$nCnt][$k]=StringMid($aKeyString[$k-1], $nCnt+1, 1)
        Next
    Next
    $ncX = $ncX + $nIncrX
    $nIncrX = 15
Next

$hSpace = GUICtrlCreateButton("", 55, $nY + 120, 345, 30, $BTN_STYLE)
$hTab   = GUICtrlCreateButton("TAB", 10, $nY + 30, 45, 30, $BTN_STYLE)
$hEnter = GUICtrlCreateButton("Enter", 400, $nY + 60, 45, 30, $BTN_STYLE)

$hCaps  = GUICtrlCreateCheckbox( "CAPS", 10, $nY + 60, 60, 30, $BS_PUSHLIKE)
$hShift = GUICtrlCreateCheckbox( "Shift", 10, $nY + 90, 75, 30, $BS_PUSHLIKE)
$hBkspc = GUICtrlCreateButton( "<--", 415, $nY + 30, 30, 30, $BTN_STYLE)
$hLayout= GUICtrlCreateButton($aLang[0], 385, $nY + 90, 60, 30, $BTN_STYLE)
$hCopyL = GUICtrlCreateButton ( "Copy", 10, $nY + 120, 45, 30, $BTN_STYLE)
$hCopyR = GUICtrlCreateButton ( "Send", 400, $nY + 120, 45, 30, $BTN_STYLE)
$hEdit  = GUICtrlCreateEdit ("", 10, 10, 434, 100, BitOr($ES_AUTOVSCROLL, $ES_WANTRETURN,  $WS_VSCROLL))
$hClear = GUICtrlCreateButton("X", 430, $nY, 15, 30, $BTN_STYLE)

$nLangIndex = $nDefLayout * 2 - 1
FillControls($nLangIndex)

GUISetState()

While 1
    $nMsg = GUIGetMsg()
     Select
        Case ($nMsg >= $aKeys[0][0]) and ($nMsg <= $aKeys[46][0])
            AddData($aKeys[$nMsg-3][$nLangIndex + _
            BitXOR(BitAnd(GUICtrlRead($hShift), 1), BitAnd(GUICtrlRead($hCaps), 1))])
            If BitAnd(GUICtrlRead($hShift), 1) Then
                GUICtrlSetState($hShift, 4)
                FillControls($nLangIndex)
            Endif
        Case $nMsg = $hSpace
            AddData(" ")
        Case $nMsg = $hTab
            AddData(@TAB)
        Case $nMsg = $hEnter
            AddData(@CR)
            AddData(@LF)
        Case $nMsg = $hShift
            FillControls($nLangIndex+BitAnd(GUICtrlRead($hShift), 1))
        Case $nMsg = $hBkspc
            $nPos = 0
            $nEditPos = GUICtrlRecvMsg($hEdit, $EM_GETSEL)
            If UBound($nEditPos) Then $nPos = $nEditPos[0]
            $sData = GUICtrlRead($hEdit)
            $sData = StringLeft($sData, $nPos-1) & StringMid($sData, $nPos+1)
            If StringMid($sData, $nPos-1, 1) = @CR Then $sData = StringLeft($sData, $nPos-2) & StringMid($sData, $nPos)
            GUICtrlSetData($hEdit, $sData)
            GUICtrlSetState($hEdit, $GUI_FOCUS)
            GUICtrlSendMsg($hEdit, $EM_SETSEL, $nPos-1, $nPos-1)
            GUICtrlSendMsg($hEdit, $EM_SCROLLCARET, 0, 0) ; EM_SCROLLCARET
        Case $nMsg = $hLayout
            $nLangIndex = $nLangIndex + 2
            If $nLangIndex > 4 Then $nLangIndex = 1
            FillControls($nLangIndex)
            GUICtrlSetData($hLayout, $aLang[$nLangIndex/2])
        Case $nMsg = $hCopyL
            MsgBox (0, "title", GUICtrlRead($hEdit))
            ClipPut(GUICtrlRead($hEdit))
        Case $nMsg = $hCopyR
            $hMenu = GUICtrlCreateContextMenu($hCopyR)
            Dim $aHandle[1][2]
            $aWinList = WinList()
            If $aWinList[0][0] > 0 Then
                For $i = 1 To $aWinList[0][0]
                    If ($aWinList[$i][0] <> "") and _
                        BitAND(WinGetState($aWinList[$i][1]), 2) and _
                        not ($aWinList[$i][1] = $hGUI) Then
                            ReDim $aHandle[UBound($aHandle)+1][2]
                            $aHandle[UBound($aHandle)-1][0] = GUICtrlCreateMenuItem($aWinList[$i][0], $hMenu)
                            $aHandle[UBound($aHandle)-1][1] = $aWinList[$i][1]
                    Endif
                Next
            Endif
            DllCall("user32.dll", "ptr", "SendMessage", "hwnd", ControlGetHandle($hGUI, "", $hCopyR), "int", $WM_CONTEXTMENU, "hwnd", 0, "int", 0)
            ; Loop for skip unneded events (like mouse move) 
            Do
                $nMsg = GUIGetMsg()
            Until $nMsg > 0
            For $j = 1 To UBound($aHandle)-1
                If $aHandle[$j][0] = $nMsg Then
                    WinActivate($aHandle[$j][1])
                    Send(GUICtrlRead($hEdit))
                    Exitloop(1)
                Endif
            Next
            GUICtrlDelete($hMenu)
        Case ($nMsg = $hClear)
            GUICtrlSetData($hEdit, "")
            AddData("")
        Case ($nMsg = $GUI_EVENT_CLOSE)
            Exit
    EndSelect
Wend

Func AddData($sChar)
    Local $nPos = 1
    Local $nEditPos = GUICtrlRecvMsg($hEdit, $EM_GETSEL)
    GUICtrlSetData($hEdit, $sChar, 1)
    If UBound($nEditPos) Then $nPos = $nEditPos[0] + 1
    GUICtrlSetState($hEdit, $GUI_FOCUS)
    GUICtrlSendMsg($hEdit, $EM_SETSEL, $nPos, $nPos)
EndFunc

Func FillControls($index)
    For $i = 1 To 47
        GUICtrlSetData($aKeys[$i-1][0], StringUpper($aKeys[$i-1][$index]))
    Next
Endfunc
